' A_all.bas
' A 1-Wire program under development using Liberty Basic v4.04  along with LBB.exe v3.0 for compile
' Currently Only Temperature [Maxim 18B20] sensors
' Only works with LinkUSB adapter emulates DS9097U
' Serial Intf ASCII commands

       GLOBAL Buffer$,Table$,crc,TempC,TempF,NumDev,Crc16hi,Crc16lo,caryin
       DIM Table$(32)
       DIM Q(32)
       DIM Dev$(100)
[start]
        cvt$ = "b55281794FF020000CC44"                      'convert cmdFamily code 28 18B20
       rd$ = "b55281794FF020000CCBEFFFFFFFFFFFFFFFFFF"     'read scratch pad
       sn$ = "281794FF020000CC"                            'family code + serial# + crc
       Buffer$="***************************************"
       cls

     '  print "1/68= ";(1/68)*1000000,"1/69= "; (1/69)*1000000, "1/68.7255= ";(1/68.7255)*1000000
     '  y = DelayMS (10000)
     '  end

       Com = 128                                           ' com buffer may need more
       open "com4:9600,n,8,1" for random as #1             ' OPEN "COMn:baud,parity,data,stop" for random as #handle
  goto [ATE]
       open "com1:9600,n,8,1" for random as #1             ' OPEN "COMn:baud,parity,data,stop" for random as #handle

[AT]   for x = 1 to 10
       Buf$ = input$(#1,lof(#1))
       PRINT #1, "A"
       print #1, "T"
       q = DelayMS (10)
       Buf$ = "AT<"+input$(#1,lof(#1))+">"
       print Buf$
        q = DelayMS (1000)
       next x
       close #1
       end

[ATE]
Print "Find Devices-------------------------------------------------------"
       Q$ = FindDev$ ()
       Q = HexByte (Q$)                                    ' length must be 2
       for z=0 to Q
          rev$=""
          for x = 1 to len(Dev$(z))  step 2
              r$=mid$(Dev$(z),x,2)                 '
              rev$ =  r$ + rev$ 
          next x
          Dev$(z)=rev$ 
       next z
       for z=0 to Q
         Print "Entry-";z;"  ";Dev$(z)
       next z
       print  "Detected ";z ;" Devices ---- Finished"
       NumDev = z
Print "Reset---------------------------------------------------------------"
       Q$ = Reset$ ()
       print "Reset=";Buffer$
Print "GetPwr--------------------------------------------------------------"
       if Reset$ () = "P" then
          Q=GetPwr (sn$)
          Pwr$=mid$(Buffer$,21,2)
          if Pwr$="00" then print "GetPwr= ";Q;"  Parasitic power"  ' if Reset good then get power byte
       end if

Print "Convert--------------------------------------------------------------"
       if Reset$ () = "P" then                             ' if Reset good then issue convert44
          Q = Convert (sn$)
          print "Convert=";Q
       end if
'==============================================================================
    RomCmd$ = "55" : FunctCmd$ = "BE"
    Q = Command (RomCmd$,sn$,FunctCmd$,9)    ' issue cmd packet and return 9 bytes
    if Q = 0 then print "================ CMD FAILED ==================="
    Q = CheckCRC (Buffer$)
    if Q = 0 then
       print "CRC = 0 = GOOD!"
    else
       print "CRC BAD Result = ";Q
    end if
'close #1
'end

Print "Getting Temperature----------------------------------------------------"
    Q = Get18B20Temperature(Buffer$)          ' Global Buffer$
    print TempC                               ' Global TempC
    print TempF                               ' Global TempF

Print "ReadSP2--------------------------------------------------------------"
for q= 0 to NumDev-1
    sn$ =Dev$(q)
    Fc$ = left$(sn$,2)                                 ' extract Family code
    RomCmd$ = "55"
    select case Fc$
        case "28"                                      ' DS18B20 Temperature Sensor
          FunctCmd$ = "BE" : rtn = 9
          Q = Command (RomCmd$,sn$,FunctCmd$,rtn)      ' issue cmd packet and return   bytes
          gosub [CheckIO]                              ' checks if previous cmd failed then crc8

        case "1D"                                      ' DS2423 counter and memory
          FunctCmd$ = "AA" : rtn =32                   ' Read SP on DS2423 does not use crc
          Q = Command (RomCmd$,sn$,FunctCmd$,rtn)      ' issue cmd packet and return   bytes
          if Q = 0 then
            print " No Ready Condition"
            exit for
          end if
          Print "Buffer$= ";Buffer$,len(Buffer$)
            for x=1 to len(Buffer$)                    ' Hex ascii string digits
               Q$=mid$(Buffer$,x,2)                    ' get 2 characters
               x=x+1                                   ' bump x+1
               Byte  = HexByte (Q$)                    ' convert 2 string digits to 1 hex byte
            next x                                     ' do remaing string

        case "A6"                                      ' DS2438 misc Temp, adc,
          rtn = 9
          for page = 0 to 7                            ' Read all 8 pages
              page$="0"+str$(page)
              FunctCmd$ = "BE"+page$ 
              Q = Command (RomCmd$,sn$,FunctCmd$,rtn)  ' issue cmd packet and return   bytes
              gosub [CheckIO]                          ' checks if previous cmd failed then crc8
              if page=0 then
                  Q=Get2438Temperature(Buffer$,3)
                  Print "Page=0 ";TempC,TempF
              end if
          next page
    end select
next q
'==========================================================================
x$="FINISHED - COMPLETED - FINISHED"
     for x = 1 to 31
   y = DelayMS (250)
      print mid$(x$,x,1);
     next x

   y = DelayMS(3000)

     close #1
 end

[CheckIO]
      if Q = 0 then print "================ CMD FAILED ==================="
      Q = CheckCRC (Buffer$)
      if Q = 0 then
       print "CRC = 0 = GOOD!"
      else
       print "CRC BAD Result = ";Q
      end if
return


'------------------------------------------------------------------------
function CheckCRC(Buf$)                        ' Buffer$ is Global
     crc=0                                     ' crc is Global
     print "Buf$-";Buf$,"Len-";len(Buf$)
     for x=1 to len(Buf$)                      ' Hex ascii string digits
       Q$=mid$(Buf$,x,2)                       ' get 2 characters
       x=x+1                                   ' bump x+1
       Q  = HexByte (Q$)                       ' convert 2 string digits to 1 hex byte
       CheckCRC = CRC1 (Q)                     ' compute running crc for this hex byte
       print x,"Next-";Q$,CheckCRC
     next x                                    ' do remaing string
     print x,"Last-";Q$,CheckCRC
end function
'=======================================================================
function Get18B20Temperature(Buf$)
         Lsd$=mid$(Buf$,1,2)
         Msd$=mid$(Buf$,3,2)
         Lsd=HexDec(Lsd$)                      ' Lsd=HexByte (Lsd$)
         Msd=HexDec(Msd$)                      ' Msd=HexByte (Msd$)
         S = Msd and 248                       ' determine sign
         Msd=(Msd and 7)*256                   ' Adjust Msd & strip sign
         if S = 0 then                         ' sign +
            TempC = (Msd + Lsd) * 625/10000    ' * .0625
         else
            TempC = 2048 - (Msd+Lsd)           ' 2's complement
            TempC = (-1 * TempC * 625/10000)   ' negative * .0625
         end if
            TempF = ((TempC*9)/5) +32
          Get18B20Temperature = TempC
end function
'=======================================================================
function Get2438Temperature(Buf$,z)
         Lsd$=mid$(Buf$,z,2)
         Msd$=mid$(Buf$,z+2,2)
         Lsd=HexDec(Lsd$)
         Msd=HexDec(Msd$)
         S = Msd and 128                             ' determine sign   1100 1001 0000 0000  C9
         MsdC = Msd and 127
         Temp = (int(((Msd*256)+Lsd)/8))             ' adjust right shift 3
         if S = 0 then
            TempC =  Temp  * 3125/100000             ' sign +
         else
            TempC  = (((Temp xor 4095)+1) and 4095)  ' 2's complement & keep 12 bits  bit13=sign
            TempC = -1 * TempC*3125/100000           ' negative * .03125
         end if
            TempF = ((TempC*9)/5) +32
          Get2438Temperature = TempC
end function
'==================================================================================================
function HexByte(Q$)                                ' Q$ = "AB"
         if len(Q$) < 2 then exit function
         nh=asc(Q$)-48                                   ' convert to hex nibble amounts
         if nh > 9 then nh=nh-7                       '
         nh=nh*16
         nl=asc(mid$(Q$,2,1))-48                                   ' convert to hex nibble amounts
         if nl > 9 then nl=nl-7
         HexByte = nh+nl
end function
'==================================================================================================
function DelayMS(value)
         td=time$("milliseconds") + value             ' milliseconds since midnight
         while time$("milliseconds") < td             ' allow comm buffer to rcv data
         wend
end function
'==================================================================================================
function Reset()                                      '
         print #1,"r"                                 ' returns P if good

        ' while lof(#1)<3
        '  wend

         Reset = DelayMS (50)                         ' 15-16 usually
         Buf$ = input$(#1,lof(#1))
         Reset = 0
         if instr(Buf$,"P",1) > 0 then Reset = 1      ' 1 = reset ok
end function
'===============================================================================================
function Reset$()                                     ' need make Buffer$ global
         print #1,"r"                                 ' returns P
         Q = DelayMS (50)                             ' 15-16 usually
         Buf$ = input$(#1,lof(#1))
         Reset$="X"
         if instr(Buf$,"P",1) > 0 then Reset$ = "P"
         if instr(Buf$,"N",1) > 0 then Reset$ = "N"
         if instr(Buf$,"S",1) > 0 then Reset$ = "S"
end function
'================================================================================================
function GetPwr(sn$)                                     ' Read Power Supply Return  0 = parasitic   1 = +5
         print #1,"b55"+sn$+"B4FF"                       ' return 1 byte            00 = parasitic  FF = +5
         y = DelayMS (100)                               ' wait 40ms+
         Buffer$ = input$(#1,lof(#1))                    ' load buffer from comm buffer
         T=instr(Buffer$,sn$+"B4",1)                     ' locat sn-cmd start
         GetPwr=0                                        ' +5
         if mid$(Buffer$,T +18,2) = "00" then GetPwr=1   ' parasitic
end function
'================================================================================================
function Convert(sn$)
          Convert=255
          print #1,"b55"+sn$+"44"                            ' send convert cmd
          Q=DelayMS (1000)
          buf$=input$(#1,lof(#1))                             ' empty comm buffer
          Convert=1                                          ' ok
end function
'=================================================================================================
function Read18B20SP(sn$,page)
         if page > 7 then page=7
         page$="0"+str$(page)
         Fc$ = mid$(sn$,1,2)                                   ' Read Scratch Pad
         select case Fc$
          case "28"
             x=9   : x$="BE" ': print "x28--";x$
          case "1D"
            x=36  : x$="AA" ': print "x1D--";x$
          case "A6"
            x=9  : x$="BE"+page$ ': print "xA6--";x$
         end select
          for z=1 to x
             x$=x$+"F"
          next z
         x$ = "b55"+sn$+x$ 
       '  print "<";x$;">"
      '''   Read18B20SP = Command (x$,x)
         print"xxxx---";Buffer$,len(Buffer$)
       '  print "ReadSP=====";Command
end function
'==================================================================================
function Command(RomCmd$,sn$,FunctCmd$,rtn)             ' Romcmd, Function Cmd, Fc/Serial/Crc, #bytes to return
         c$ = RomCmd$ + sn$ + FunctCmd$                 ' cmd header 55-fc-xx-xx-xx-xx-xx-xx-crc-cmd = 20 text bytes
         buf$ = ""
         for x=1 to rtn*2
           buf$ = buf$ + "F"
         next x                                         ' b = adapter byte mode
         cm$ = "b" + c$ + buf$                          ' b55282ABABC02000059BE  - command packet
         print "CMD-";cm$
         Q=Reset()                                      ' Q=1=good reset
         Command=0                                      ' preset bad return status
         if Q=0 then goto [ef]                          ' Reset2 Failed
         print #1,cm$                                   ' issue command pscket to 1-wire adapter                                                       ' b55282ABABC02000059BE-FFFFFFFFFFFFFFFFFFFF
         Q=DelayMS (rtn*15)                             ' Global Buffer$ for return data                         '
         Buffer$=input$(#1,lof(#1))                     '  55282ABABC02000059BE-89014B467FFF07102DFF
         Print "Buffer$ B4 Trim-- <";Buffer$;">",len(Buffer$)
         Q = RTrimHex (Buffer$)                         ' remove trailing non hex text digits
         blen = len(Buffer$)                            ' length of Buffer$ 
         clen = len(c$)
         c=instr(Buffer$,c$,1)                          ' locate command header start in buffer
         Buffer$=mid$(Buffer$,c+clen,blen)              ' position Data at Start of Buffer
         if blen-clen > rtn*2 then Command = 1          ' sufficent data returned
         Buffer$ = Left$(Buffer$,rtn*2)                 ' set desired end of buffer [ remove trailing junk ]
         Print "Buffer$-- <";Buffer$;">",len(Buffer$);" - ";c$
         Print "====*===*===*====*===*====*===*===*====*===*====*===*===*====*===*=="
[ef]
end function
'======================================================================================
function Read18B20SP$(sn$)
         Q$ = Reset$ ()
         if Reset$ <> "P" then
              Buffer$="NOINFO"
              goto [Rspx]                                   ' Read Scratch Pad
         end if
         print #1,"b55"+sn$+"BE"+"FFFFFFFFFFFFFFFFFFFF"     ' Get SP Rcv 9 bytes
         Q=DelayMS (1200)                                   '
         Buf$=input$(#1,lof(#1))                            '
         T=instr(buf$,sn$+"BE",1)                           ' find sn+BE in SP data
         Buffer$=mid$(Buffer$,T+18,18)                      ' Adjust SP packet in Global Buffer$ 
[Rspx]   Read18B20SP$ = Buffer$ 
end function
'========================================================================================
function RTrimHex(buf$)                                     ' use global buffer$
[rth]    x = len(buf$) : Q=0
         x$=right$(buf$,1)
         if (asc(x$) < 48) or (asc(x$) >70) or (asc(x$) > 57 and asc(x$) <65) then
           buf$ = left$(buf$,x-1)
           Q=1
           RTrimHex=1                                       ' made a change
         end if
         if Q=1 then goto [rth]
end function

'========================================================================================
function CRC8(Q)
        for k=1 to 9                                  ' check 9 bytes
            for i=0 to 7                              ' 8 bits / byte
               tmpbit = crc xor Q(k)
               tmpbit = tmpbit and 1                  ' print "tmpbit= ";tmpbit;
               Q(k)= int(Q(k)/2)                      ' print "  A(k)/2 = ";A(k);
               if tmpbit = 1 then crc = crc xor 24    ' print "  crc1 = ";crc;
               crc = int(crc/2)                       ' print "  crc2 = ";crc;
               crc = crc or (tmpbit*128)             ' print "  crc3 = ";crc
            next i
        next k
        CRC8 = crc
end function
'========================================================================================
function CRC1(Byte)                                 ' compute crc for a byte
         for i=0 to 7                               ' 8 bits / byte
               tmpbit = crc xor Byte                ' Print "crc=";crc;" Byte=";Byte;
               tmpbit = tmpbit and 1                ' print " tmpbit= ";tmpbit;
               Byte = int(Byte/2)                   ' print " Byte/2 = ";Byte;
               if tmpbit = 1 then crc = crc xor 24  ' print " crca = ";crc;
               crc = int(crc/2)                     ' print " crcb = ";crc;
               crc = crc or (tmpbit*128)            ' print " crcc = ";crc
         next i
         CRC1 = crc
end function

'=======================================================================================

function FindDev$()                            ' Dev$ = implied Global
         print #1,"r"                          ' returns P
         while lof(#1)<3
          wend
         z$=input$(#1,lof(#1))
         print #1,"f"                          ' get next dev#
    for x=0 to 8
         W = DelayMS (100)
         Dev$(x)=input$(#1,lof(#1))              ' dump comm buffer
         y=instr(Dev$(x),"+,",1)                 ' locate  +,
         z=instr(Dev$(x),"-,",1)                 ' locate  -,
         if y > 0 then
            Dev$(x)=mid$(Dev$(x),y+2,16)           ' save code
         end if
         if z > 0 then                         ' -, last found
            Dev$(x)=mid$(Dev$(x),z+2,16)           ' save code
            exit for
         end if        ' save code
         print #1,"n"
   next x
         if x < 10 then
            FindDev$= "0"+str$(x)
         else
            FindDev$ = str$(x)        '# devices
         end if
end function
'=========================================================================================
[Crc16]                      ' compute crc16 on 1 Byte  byref caryin [caryin gets changed]
            wreg = Byte                                         '  input byte --> wreg
            wreg = wreg xor Crc16lo                             '  wreg xor crclo
            index = wreg                                        '  wreg --> index
            wreg = Crc16hi                                      '  wreg  --> crchi
            Crc16lo = wreg                                      '  crchi >> 8 to crclo
            temp = 0                                            '  clrf   0 --> temp
            caryin = 0                                          '  clrf   0 --> cary
            wreg = RRF (caryin,index)                           '  index >> 1 --> wreg
            index = index xor wreg                              '  wreg xor index --> index
            temp = RRF (caryin,temp)                            '  temp >> 1 --> temp
            wreg = RRF (caryin,index)                           '  index >> 1  --> index
            Crc16hi = wreg                                      '  wreg --: crchi
            temp = RRF (caryin, temp)                           '  temp >> 1  -->  temp
            index = RLF (caryin,index)                          '  index  << 1  --> index
            index = index xor wreg                              '  wreg xor index --> index
            index = SWAP (index)                                '  index swap nibs --> wreg
            index = index xor wreg                              '  wreg xor index  --> index
            wreg = temp                                         '  temp  --> wreg
            if index and 1 = 1 then wreg = wreg xor 1
            Crc16lo = Crc16lo xor wreg                          '  crclo xor wreg --> crclo
            wreg = 192                    ' 0xC0                '  0xC) --> wreg
            if index and 1 = 1 then Crc16hi = Crc16hi xor wreg
            print "CRC16hi, CRC16lo, Byte ",DecHex$(Crc16hi*256+Crc16lo),DecHex$(Byte)
            return
'============================================================================================
function RRF(byref caryin,value)
             Cin = caryin*128
             caryout = value and 1
             work = int(value/2) + Cin            ' cary in is 0 or 1
             caryin = caryout
             RRF = work and 255                      ' limit to byte
end function
'=============================================================================================
function RLF(byref caryin,value)
             caryout =  value and 128
             work = value*2 + caryin                ' cary in is 0/1
             caryin = int(caryout/128)                     ' make 0/1
             RLF = work and 255
end function
'=============================================================================================
function SWAP(byte)
              nh=byte/16
              nl=byte and 15
              SWAP = (nl*16)+nh
end function
'==============================================================================================
function Testbit(val, bit)                  ' binary byte/word/Dword whatever  and bit #  0-15 ?
         tb = 2^bit
         Testbit = (val and tb)/tb          ' return 1/0
end function
'=============================================================================================
function Tstbit(val, bit)                  ' binary byte/word/Dword whatever  and bit #  0-15 ?
         Tstbit=0
         if (val and 2^bit) > 0 then Tstbit=1   '' if byte and [1,2,4,8,16,32,64,128] > 0 then bit present
end function
'=============================================================================================
function Flipbit(val,bit)
             fb = 2^bit
             if  (val and fb) > 0 then
                 Flipbit = val xor fb    ' 1 - make bit a zero
             else
                 Flipbit = val or  fb    ' 0 - make 1
             end if
end function
'=============================================================================================

